diff --git src/VBox/Additions/common/crOpenGL/fakedri_drv.c src/VBox/Additions/common/crOpenGL/fakedri_drv.c
index f6793da..1ba261d 100644
--- src/VBox/Additions/common/crOpenGL/fakedri_drv.c
+++ src/VBox/Additions/common/crOpenGL/fakedri_drv.c
@@ -30,7 +30,7 @@
 #include <elf.h>
 #include <unistd.h>
 
-#if defined(RT_OS_FREEBSD)
+#if defined(RT_OS_FREEBSD) || defined(RT_OS_NETBSD)
 #include <sys/param.h>
 #include <fcntl.h>
 #include <gelf.h>
@@ -62,6 +62,9 @@ typedef enum {
 # ifdef RT_OS_FREEBSD
 #  define DRI_DEFAULT_DRIVER_DIR "/usr/local/lib/dri"
 #  define DRI_XORG_DRV_DIR "/usr/local/lib/xorg/modules/drivers/"
+# elif defined(RT_OS_NETBSD)
+#  define DRI_DEFAULT_DRIVER_DIR "/usr/X11R7/lib/modules/dri"
+#  define DRI_XORG_DRV_DIR "/usr/X11R7/lib/modules/divers/"
 # else
 #  define DRI_DEFAULT_DRIVER_DIR "/usr/lib64/dri:/usr/lib/dri:/usr/lib/x86_64-linux-gnu/dri:/usr/lib/xorg/modules/dri"
 #  define DRI_XORG_DRV_DIR "/usr/lib/xorg/modules/drivers/"
@@ -70,6 +73,9 @@ typedef enum {
 # ifdef RT_OS_FREEBSD
 #  define DRI_DEFAULT_DRIVER_DIR "/usr/local/lib/dri"
 #  define DRI_XORG_DRV_DIR "/usr/local/lib/xorg/modules/drivers/"
+# elif defined(RT_OS_NETBSD)
+#  define DRI_DEFAULT_DRIVER_DIR "/usr/X11R7/lib/modules/dri"
+#  define DRI_XORG_DRV_DIR "/usr/X11R7/lib/modules/divers/"
 # else
 #  define DRI_DEFAULT_DRIVER_DIR "/usr/lib/dri:/usr/lib/i386-linux-gnu/dri:/usr/lib/xorg/modules/dri"
 #  define DRI_XORG_DRV_DIR "/usr/lib/xorg/modules/drivers/"
@@ -228,7 +234,7 @@ vboxApplyPatch(const char* psFuncName, void *pDst, const void *pSrc, unsigned lo
 
 #define FAKEDRI_JMP64_PATCH_SIZE 13
 
-#if defined(RT_OS_FREEBSD)
+#if defined(RT_OS_FREEBSD) || defined(RT_OS_NETBSD)
 /* Provide basic dladdr1 flags */
 enum {
 	RTLD_DL_SYMENT	= 1
@@ -696,6 +702,20 @@ void __attribute__ ((constructor)) vbox_install_into_mesa(void)
     vboxFillGLXAPITable(&glxim);
     /* Now patch functions exported by libGL.so */
     vboxPatchMesaExports();
+
+#if defined(RT_OS_NETBSD)
+    /*
+     * libGL.so will fail to load this because
+     * "core dri or dri2 extension not found".
+     * As it happens with vboxvideo, this is something that more or less should
+     * happen. However, in that case this library will be unloaded and
+     * everything breaks.
+     * So open self to prevent this.
+     * XXX: I don't know why things work on Linux but not on NetBSD.
+     */
+    /* XXX: hardcoded path */
+    dlopen("/usr/X11R7/lib/modules/dri/vboxvideo_dri.so", 0);
+#endif
 }
 
 /*
diff --git src/VBox/Additions/common/crOpenGL/load.c src/VBox/Additions/common/crOpenGL/load.c
index 5864aea..60c2078 100644
--- src/VBox/Additions/common/crOpenGL/load.c
+++ src/VBox/Additions/common/crOpenGL/load.c
@@ -481,7 +481,11 @@ static void stubSPUSafeTearDown(void)
 }
 
 
+#if defined(RT_OS_NETBSD)
+static void __attribute__ ((destructor)) stubExitHandler(void)
+#else
 static void stubExitHandler(void)
+#endif
 {
     stubSPUSafeTearDown();
     signal(SIGTERM, SIG_DFL);
@@ -570,7 +574,7 @@ static void stubInitVars(void)
 #endif
     crHashtableAdd(stub.windowTable, 0, defaultWin);
 
-#if 1
+#if !defined(RT_OS_NETBSD)
     atexit(stubExitHandler);
     signal(SIGTERM, stubSignalHandler);
     signal(SIGINT, stubSignalHandler);
diff --git src/VBox/Additions/netbsd/Makefile.kmk src/VBox/Additions/netbsd/Makefile.kmk
new file mode 100644
index 0000000..4d0de81
--- /dev/null
+++ src/VBox/Additions/netbsd/Makefile.kmk
@@ -0,0 +1,29 @@
+# $Id: Makefile.kmk $
+## @file
+# Sub-Makefile for the NetBSD guest additions base directory.
+#
+
+#
+# Copyright (C) 2008-2012 Oracle Corporation
+#
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+#
+
+SUB_DEPTH = ../../../..
+include $(KBUILD_PATH)/subheader.kmk
+
+ifneq ($(KBUILD_HOST),netbsd)
+$(error "The NetBSD guest additions installer can only be built on NetBSD!")
+endif
+
+# Include sub-makefiles.
+#include $(PATH_SUB_CURRENT)/vboxvfs/Makefile.kmk
+include $(PATH_SUB_CURRENT)/drm/Makefile.kmk
+
+include $(FILE_KBUILD_SUB_FOOTER)
diff --git src/VBox/Additions/netbsd/drm/Makefile.kmk src/VBox/Additions/netbsd/drm/Makefile.kmk
new file mode 100644
index 0000000..3a742de
--- /dev/null
+++ src/VBox/Additions/netbsd/drm/Makefile.kmk
@@ -0,0 +1,53 @@
+# $Id: Makefile.kmk $
+## @file
+# Sub-Makefile for the vboxvideo DRM module (NetBSD kernel OpenGL module).
+#
+
+#
+# Copyright (C) 2009-2012 Oracle Corporation
+#
+# This file is part of VirtualBox Open Source Edition (OSE), as
+# available from http://www.virtualbox.org. This file is free software;
+# you can redistribute it and/or modify it under the terms of the GNU
+# General Public License (GPL) as published by the Free Software
+# Foundation, in version 2 as it comes in the "COPYING" file of the
+# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+#
+
+
+SUB_DEPTH = ../../../../..
+include $(KBUILD_PATH)/subheader.kmk
+
+ifdef VBOX_WITH_ADDITION_DRIVERS
+ SYSMODS  += vboxdrm
+endif
+ifneq ($(KBUILD_HOST),netbsd)
+$(error "The NetBSD guest additions can only be built on NetBSD!")
+endif
+
+#
+# vboxdrm - The Video DRM (Direct Rendering Module) kernel module
+#
+vboxdrm_TEMPLATE      = VBOXGUESTR0
+vboxdrm_NAME          = vboxdrm
+vboxdrm_DEFS          = _MODULE _KERNEL __KERNEL__
+vboxdrm_INCS.netbsd  += \
+    $(vboxdrm_0_OUTDIR) \
+    $(VBOX_NETBSD_SRC)/external/bsd/common/include \
+    $(VBOX_NETBSD_SRC)/external/bsd/drm2/include \
+    $(VBOX_NETBSD_SRC)/external/bsd/drm2/dist/uapi \
+    $(VBOX_NETBSD_SRC)/external/bsd/drm2/dist/include
+
+vboxdrm_SOURCES       = vbox_drv.c
+vboxdrm_LIBS          = 
+vboxdrm_ORDERDEPS.netbsd = $(vboxdrm_0_OUTDIR)/opt_drm.h
+vboxdrm_CLEAN.netbsd = $(vboxdrm_DEPS)
+
+# Header for DRM not included by us.
+$$(vboxdrm_0_OUTDIR)/opt_drm.h:
+	$(QUIET)$(MKDIR) -p $(vboxdrm_0_OUTDIR)
+	$(QUIET)touch $(vboxdrm_0_OUTDIR)/opt_drm.h
+
+include $(FILE_KBUILD_SUB_FOOTER)
+
diff --git src/VBox/Additions/netbsd/drm/vbox_drv.c src/VBox/Additions/netbsd/drm/vbox_drv.c
new file mode 100644
index 0000000..f1bb8b7
--- /dev/null
+++ src/VBox/Additions/netbsd/drm/vbox_drv.c
@@ -0,0 +1,214 @@
+/* $NetBSD: vbox_drv.c,v 1.2 2011/08/28 17:18:31 jmcneill Exp $ */
+
+/*
+ * Copyright (c) 2011 Jared D. McNeill <jmcneill@invisible.ca>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. The name of the author may not be used to endorse or promote products
+ *    derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
+ * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
+ * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+ * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+__KERNEL_RCSID(0, "$NetBSD: vbox_drv.c,v 1.2 2011/08/28 17:18:31 jmcneill Exp $");
+
+#include "product-generated.h"
+
+#include <sys/types.h>
+#include <sys/param.h>
+#include <sys/conf.h>
+#include <sys/device.h>
+#include <sys/module.h>
+#include <sys/mount.h>
+#include <drm/drmP.h>
+#include <dev/pci/pcivar.h>
+
+struct vboxdrm_softc {
+    device_t dev;
+    struct pci_dev pci_dev;
+    struct drm_device *drm_dev;
+};
+
+static int
+vboxdrm_driver_load(struct drm_device *dev, unsigned long flags)
+{
+    return 0;
+}
+
+static struct drm_driver vboxdrm_driver =
+{
+    .load = vboxdrm_driver_load,
+    .mmap_object = &drm_gem_or_legacy_mmap_object,
+    .fops = NULL,
+    .name = "vboxvideo",
+    .desc = VBOX_PRODUCT " Graphics Card",
+    .date = "20090303",
+    .major = 1,
+    .minor = 0,
+    .patchlevel = 0
+};
+
+static int
+vboxdrm_match(device_t parent, cfdata_t match, void *opaque)
+{
+    const struct pci_attach_args *const pa = opaque;
+
+printf("vboxdrm_match\n");
+
+    if (PCI_VENDOR(pa->pa_id) != 0x80EE) {
+        return 0;
+    }
+    if (PCI_CLASS(pa->pa_class) != PCI_CLASS_DISPLAY) {
+        return 0;
+    }
+    if (PCI_PRODUCT(pa->pa_id) != 0xBEEF) {
+        return 0;
+    }
+
+    return 1;
+}
+
+static void
+vboxdrm_attach(device_t parent, device_t self, void *opaque)
+{
+    const struct pci_attach_args *const pa = opaque;
+    struct vboxdrm_softc *sc = device_private(self);
+    const unsigned long cookie = (unsigned long)(uintptr_t)sc;
+    int error;
+
+    sc->dev = self;
+
+    pci_aprint_devinfo(pa, NULL);
+
+	pmf_device_register(self, NULL, NULL);
+
+    error = -drm_pci_attach(self, pa, &sc->pci_dev, &vboxdrm_driver, cookie,
+        &sc->drm_dev);
+    if (error) {
+        aprint_error_dev(self, "drm_pci_attach: %d\n", error);
+        return;
+    }
+}
+
+static int
+vboxdrm_detach(device_t self, int flags)
+{
+    struct vboxdrm_softc *sc = device_private(self);
+    int error;
+
+	pmf_device_deregister(self);
+
+    if (sc->drm_dev == NULL) {
+        return 0;
+    }
+
+    error = -drm_pci_detach(sc->drm_dev, flags);
+    if (error) {
+        aprint_error_dev(self, "drm_pci_detach: %d\n", error);
+        return error;
+    }
+    sc->drm_dev = NULL;
+
+    return 0;
+}
+
+CFATTACH_DECL_NEW(
+    vboxdrm,
+    sizeof(struct vboxdrm_softc),
+    vboxdrm_match,
+    vboxdrm_attach,
+    vboxdrm_detach,
+    NULL
+);
+
+MODULE(MODULE_CLASS_DRIVER, vboxdrm, "drmkms,drmkms_pci");
+
+CFDRIVER_DECL(vboxdrm, DV_DULL, NULL);
+
+static struct cfdriver * const cfdriver_ioconf_vboxdrm[] = {
+	&vboxdrm_cd,
+	NULL
+};
+
+extern struct cfattach vboxdrm_ca;
+
+/* locators */
+static int loc[1] = {-1};
+
+static const struct cfparent pspec0 = {
+	"drm", NULL, DVUNIT_ANY
+};
+
+#define NORM FSTATE_NOTFOUND
+#define STAR FSTATE_STAR
+
+static struct cfdata cfdata_ioconf_vboxdrm[] = {
+    /* driver           attachment    unit state loc   flags pspec */
+/*  0: vboxdrm* at pci? dev ? function ? */
+    { "vboxdrm",		"vboxdrm",	 0, STAR,     loc,      0, &pspec0 },
+    { NULL,		NULL,		 0, 0,    NULL,      0, NULL }
+};
+
+static struct cfattach * const vboxdrm_cfattachinit[] = {
+	&vboxdrm_ca, NULL
+};
+
+static const struct cfattachinit cfattach_ioconf_vboxdrm[] = {
+	{ "vboxdrm", vboxdrm_cfattachinit },
+	{ NULL, NULL }
+};
+
+static int
+vboxdrm_modcmd(modcmd_t cmd, void *opaque)
+{
+    extern int drm_guarantee_initialized(void);
+
+    int error;
+	switch (cmd) {
+	case MODULE_CMD_INIT:
+        error = drm_guarantee_initialized();
+        if (error) {
+            aprint_error("vboxdrm: drm_guarantee_initialized: %d\n", error);
+            return error;
+        }
+        error = drm_pci_init(&vboxdrm_driver, NULL);
+        if (error) {
+            aprint_error("vboxdrm: drm_pci_init failed\n");
+            return error;
+        }
+		error = config_init_component(cfdriver_ioconf_vboxdrm,
+		    cfattach_ioconf_vboxdrm, cfdata_ioconf_vboxdrm);
+        if (error) {
+            aprint_error("vboxdrm: failed to init component: %d\n", error);
+            return error;
+        }
+        return 0;
+	case MODULE_CMD_FINI:
+		error = config_fini_component(cfdriver_ioconf_vboxdrm,
+		    cfattach_ioconf_vboxdrm, cfdata_ioconf_vboxdrm);
+        if (error) {
+            aprint_error("vboxdrm: failed to fini component: %d\n", error);
+            return error;
+        }
+        drm_pci_exit(&vboxdrm_driver, NULL);
+        return 0;
+	default:
+		return ENOTTY;
+	}
+}
diff --git src/VBox/Additions/x11/VBoxClient/Makefile.kmk src/VBox/Additions/x11/VBoxClient/Makefile.kmk
index 9a4e587..6611827 100644
--- src/VBox/Additions/x11/VBoxClient/Makefile.kmk
+++ src/VBox/Additions/x11/VBoxClient/Makefile.kmk
@@ -41,6 +41,8 @@ VBoxClient_LIBS.freebsd = \
 	iconv
 VBoxClient_LIBS.linux = \
 	dl
+VBoxClient_LIBS.netbsd = \
+	pthread
 VBoxClient_LIBS.solaris = \
 	dl
 VBoxClient_LIBS = \
@@ -52,6 +54,8 @@ VBoxClient_LIBS = \
 VBoxClient_LIBS += \
 	supc++ \
 	gcc_eh
+VBoxClient_LDFLAGS.netbsd += \
+    -Wl,-rpath /usr/X11R7/lib
 ifdef VBOX_X11_SEAMLESS_GUEST
  VBoxClient_DEFS += SEAMLESS_GUEST DYNAMIC_RESIZE
  VBoxClient_SOURCES += \
diff --git src/VBox/Additions/x11/VBoxClient/seamless-guest.h src/VBox/Additions/x11/VBoxClient/seamless-guest.h
index e468531..9d6b05c 100644
--- src/VBox/Additions/x11/VBoxClient/seamless-guest.h
+++ src/VBox/Additions/x11/VBoxClient/seamless-guest.h
@@ -43,7 +43,7 @@ public:
     };
 };
 
-#if defined(RT_OS_LINUX) || defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD)
+#if defined(RT_OS_LINUX) || defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD) || defined(RT_OS_NETBSD)
 # include "seamless-x11.h"  /* for VBoxGuestSeamlessGuestImpl */
 #else
 # error Port me
diff --git src/VBox/Additions/x11/vboxvideo/Makefile.kmk src/VBox/Additions/x11/vboxvideo/Makefile.kmk
index 7a9a0c8..edc6ffb 100644
--- src/VBox/Additions/x11/vboxvideo/Makefile.kmk
+++ src/VBox/Additions/x11/vboxvideo/Makefile.kmk
@@ -33,7 +33,7 @@ endif
 vboxvideo_13_DEFS := $(vboxvideo_70_DEFS) VBOXVIDEO_13
 vboxvideo_15_DEFS := \
 	$(vboxvideo_13_DEFS) NO_ANSIC PCIACCESS XSERVER_LIBPCIACCESS
-if1of ($(KBUILD_TARGET), linux solaris)
+if1of ($(KBUILD_TARGET), linux netbsd solaris)
  vboxvideo_15_DEFS += \
  	VBOX_DRI
 endif
@@ -198,7 +198,7 @@ DLLS += vboxvideo_drv_15
 vboxvideo_drv_15_TEMPLATE = VBOXGUESTR3XORGMOD
 vboxvideo_drv_15_CFLAGS := $(vboxvideo_drv_70_CFLAGS)
 vboxvideo_drv_15_DEFS := $(vboxvideo_15_DEFS) XORG_VERSION_CURRENT=100503000
-if1of ($(KBUILD_TARGET), linux solaris)
+if1of ($(KBUILD_TARGET), linux netbsd solaris)
  vboxvideo_drv_15_DEFS += \
  	VBOX_DRI_OLD
 endif
@@ -207,7 +207,7 @@ vboxvideo_drv_15_INCS = \
 	$(VBOX_PATH_X11_ROOT)/xorg-server-1.5.3
 vboxvideo_drv_15_INCS += $(PATH_ROOT)/src/VBox/Runtime/include
 vboxvideo_drv_15_SOURCES  = $(vboxvideo_drv_13_SOURCES)
-if1of ($(KBUILD_TARGET), linux solaris)
+if1of ($(KBUILD_TARGET), linux netbsd solaris)
  vboxvideo_drv_15_SOURCES += \
  	vboxvideo_dri.c
 endif
@@ -220,7 +220,7 @@ DLLS += vboxvideo_drv_16
 vboxvideo_drv_16_TEMPLATE = VBOXGUESTR3XORGMOD
 vboxvideo_drv_16_CFLAGS := $(vboxvideo_drv_70_CFLAGS)
 vboxvideo_drv_16_DEFS := $(vboxvideo_15_DEFS) XORG_VERSION_CURRENT=100600000
-if1of ($(KBUILD_TARGET), linux solaris)
+if1of ($(KBUILD_TARGET), linux netbsd solaris)
  vboxvideo_drv_16_DEFS += \
  	VBOX_DRI_OLD
 endif
@@ -243,12 +243,11 @@ vboxvideo_drv_17_INCS = \
 	$(VBOX_PATH_X11_ROOT)/xorg-server-1.7.7
 vboxvideo_drv_17_INCS += $(PATH_ROOT)/src/VBox/Runtime/include
 vboxvideo_drv_17_SOURCES := $(vboxvideo_drv_13_SOURCES)
-if1of ($(KBUILD_TARGET), linux solaris)
+if1of ($(KBUILD_TARGET), linux netbsd solaris)
  vboxvideo_drv_17_SOURCES += \
  	vboxvideo_dri2.c
 endif
 
-
 #
 # vboxvideo_drv_18
 #
diff --git src/VBox/Additions/x11/x11stubs/Makefile.kmk src/VBox/Additions/x11/x11stubs/Makefile.kmk
index d7c4d86..e7a703b 100644
--- src/VBox/Additions/x11/x11stubs/Makefile.kmk
+++ src/VBox/Additions/x11/x11stubs/Makefile.kmk
@@ -27,6 +27,7 @@ libXcomposite_TEMPLATE   = VBoxGuestR3Dll
 libXcomposite_INST       = $(INST_LIB)
 # This may need fixing later.
 libXcomposite_SONAME     = libXcomposite.so.1
+libXcomposite_SONAME.netbsd     = libXcomposite.so.2
 libXcomposite_SOURCES    = libXcomposite-1.0.0/libXcomposite.c
 
 #
@@ -37,6 +38,7 @@ libXdamage_TEMPLATE   = VBoxGuestR3Dll
 libXdamage_INST       = $(INST_LIB)
 # This may need fixing later.
 libXdamage_SONAME     = libXdamage.so.1
+libXdamage_SONAME.netbsd     = libXdamage.so.2
 libXdamage_SOURCES    = libXdamage-1.1.0/libXdamage.c
 
 #
@@ -48,6 +50,7 @@ libXfixes_INST       = $(INST_LIB)
 # This may need fixing later.
 libXfixes_SONAME.linux      = libXfixes.so.3
 libXfixes_SONAME.solaris    = libXfixes.so.1
+libXfixes_SONAME.netbsd     = libXfixes.so.4
 libXfixes_SOURCES    = libXfixes-3.1.0/libXfixes.c
 
 #
@@ -58,6 +61,7 @@ libXext_TEMPLATE   = VBoxGuestR3Dll
 libXext_INST       = $(INST_LIB)
 # This may need fixing later.
 libXext_SONAME.linux       = libXext.so.6
+libXext_SONAME.netbsd      = libXext.so.7
 libXext_SONAME.solaris     = libXext.so.0
 libXext_SOURCES    = libXext-6.4.0/libXext.c
 
diff --git src/VBox/GuestHost/OpenGL/include/chromium.h src/VBox/GuestHost/OpenGL/include/chromium.h
index 816aee9..dc54d2d 100644
--- src/VBox/GuestHost/OpenGL/include/chromium.h
+++ src/VBox/GuestHost/OpenGL/include/chromium.h
@@ -67,7 +67,7 @@
 
 #ifdef DARWIN
 # include <stddef.h>
-#elif !defined(FreeBSD)
+#elif !defined(FreeBSD) && !defined(NetBSD)
 #  include <malloc.h>  /* to get ptrdiff_t used below */
 #endif
 
diff --git src/VBox/GuestHost/OpenGL/include/cr_dll.h src/VBox/GuestHost/OpenGL/include/cr_dll.h
index 4258b57..6ca184c 100644
--- src/VBox/GuestHost/OpenGL/include/cr_dll.h
+++ src/VBox/GuestHost/OpenGL/include/cr_dll.h
@@ -22,7 +22,7 @@ typedef struct {
 	char *name;
 #if defined(WINDOWS)
 	HINSTANCE hinstLib;
-#elif defined(IRIX) || defined(IRIX64) || defined(Linux) || defined(FreeBSD) || defined(AIX) || defined(SunOS) || defined(OSF1)
+#elif defined(IRIX) || defined(IRIX64) || defined(Linux) || defined(FreeBSD) || defined(AIX) || defined(SunOS) || defined(OSF1) || defined(NetBSD)
 	void *hinstLib;
 #elif defined(DARWIN)
 	void *hinstLib;		/* void to avoid including the headers */
diff --git src/VBox/GuestHost/OpenGL/include/cr_timer.h src/VBox/GuestHost/OpenGL/include/cr_timer.h
index 316ba34..dc5111e 100644
--- src/VBox/GuestHost/OpenGL/include/cr_timer.h
+++ src/VBox/GuestHost/OpenGL/include/cr_timer.h
@@ -35,7 +35,7 @@ typedef struct Timer
 #elif defined(WINDOWS)
 	LARGE_INTEGER performance_counter, performance_frequency;
 	double one_over_frequency;
-#elif defined( Linux ) || defined( FreeBSD ) || defined(DARWIN) || defined(AIX) || defined (SunOS) || defined(OSF1)
+#elif defined( Linux ) || defined( FreeBSD ) || defined(DARWIN) || defined(AIX) || defined (SunOS) || defined(OSF1) || defined(NetBSD)
 	struct timeval timeofday;
 #endif
 } CRTimer;
diff --git src/VBox/GuestHost/OpenGL/spu_loader/glloader.py src/VBox/GuestHost/OpenGL/spu_loader/glloader.py
index a84f729..6e8c3f6 100644
--- src/VBox/GuestHost/OpenGL/spu_loader/glloader.py
+++ src/VBox/GuestHost/OpenGL/spu_loader/glloader.py
@@ -34,7 +34,7 @@ print """
 #  define SYSTEM_AGL "AGL"
 # endif
 #include <string.h> /* VBOX */
-#elif defined(IRIX) || defined(IRIX64) || defined(Linux) || defined(FreeBSD) || defined(AIX) || defined(SunOS) || defined(OSF1)
+#elif defined(IRIX) || defined(IRIX64) || defined(Linux) || defined(FreeBSD) || defined(AIX) || defined(SunOS) || defined(OSF1) || defined(NetBSD)
 #include <string.h>
 #if defined(AIX)
 #define SYSTEM_GL "libGL.o"
@@ -150,7 +150,7 @@ __findSystemLib( const char *provided_system_path, char *lib )
 		}*/
 #endif
 	}
-#if !defined(__linux__) && !defined(SunOS) && !defined(__FreeBSD__)
+#if !defined(__linux__) && !defined(SunOS) && !defined(__FreeBSD__) && !defined(__NetBSD__)
 	crStrcat( system_path, "/" );
 #endif
 #if !defined(CR_NO_GL_SYSTEM_PATH)
diff --git src/VBox/GuestHost/OpenGL/util/dll.c src/VBox/GuestHost/OpenGL/util/dll.c
index dbc6175..bdc5117 100644
--- src/VBox/GuestHost/OpenGL/util/dll.c
+++ src/VBox/GuestHost/OpenGL/util/dll.c
@@ -14,7 +14,7 @@
 #include <string.h>
 #endif
 
-#if defined(IRIX) || defined(IRIX64) || defined(Linux) || defined(FreeBSD) || defined(AIX) || defined(DARWIN) || defined(SunOS) || defined(OSF1)
+#if defined(IRIX) || defined(IRIX64) || defined(Linux) || defined(FreeBSD) || defined(AIX) || defined(DARWIN) || defined(SunOS) || defined(OSF1) || defined(NetBSD)
 #include <dlfcn.h>
 #endif
 
@@ -269,7 +269,7 @@ CRDLL *crDLLOpen( const char *dllname, int resolveGlobal )
 		dll_err = "Unknown DLL type";
 		break;
 	};
-#elif defined(IRIX) || defined(IRIX64) || defined(Linux) || defined(FreeBSD) || defined(AIX) || defined(SunOS) || defined(OSF1)
+#elif defined(IRIX) || defined(IRIX64) || defined(Linux) || defined(FreeBSD) || defined(AIX) || defined(SunOS) || defined(OSF1) || defined(NetBSD)
 	if (resolveGlobal)
 		dll->hinstLib = dlopen( dllname, RTLD_LAZY | RTLD_GLOBAL );
 	else
@@ -322,7 +322,7 @@ CRDLLFunc crDLLGetNoError( CRDLL *dll, const char *symname )
 
 	return (CRDLLFunc) NSAddressOfSymbol( nssym );
 
-#elif defined(IRIX) || defined(IRIX64) || defined(Linux) || defined(FreeBSD) || defined(AIX) || defined(SunOS) || defined(OSF1)
+#elif defined(IRIX) || defined(IRIX64) || defined(Linux) || defined(FreeBSD) || defined(AIX) || defined(SunOS) || defined(OSF1) || defined(NetBSD)
 	return (CRDLLFunc) dlsym( dll->hinstLib, symname );
 #else
 #error CR DLL ARCHITETECTURE
@@ -366,7 +366,7 @@ void crDLLClose( CRDLL *dll )
 		NSUnLinkModule( (NSModule) dll->hinstLib, 0L );
 		break;
 	}
-#elif defined(IRIX) || defined(IRIX64) || defined(Linux) || defined(FreeBSD) || defined(AIX) || defined(SunOS) || defined(OSF1)
+#elif defined(IRIX) || defined(IRIX64) || defined(Linux) || defined(FreeBSD) || defined(AIX) || defined(SunOS) || defined(OSF1) || defined(NetBSD)
 	/*
 	 * Unloading Nvidia's libGL will crash VirtualBox later during shutdown.
 	 * Therefore we will skip unloading it. It will be unloaded later anway
diff --git src/VBox/GuestHost/OpenGL/util/environment.c src/VBox/GuestHost/OpenGL/util/environment.c
index 82fd619..092cd26 100644
--- src/VBox/GuestHost/OpenGL/util/environment.c
+++ src/VBox/GuestHost/OpenGL/util/environment.c
@@ -12,7 +12,7 @@
 
 void crSetenv( const char *var, const char *value )
 {
-#if defined(LINUX) || defined(FREEBSD) || defined(DARWIN)
+#if defined(LINUX) || defined(FREEBSD) || defined(DARWIN) || defined(NETBSD)
 	setenv( var, value, 1 /* replace */ );
 #else
 	unsigned long len;
diff --git src/VBox/GuestHost/OpenGL/util/timer.c src/VBox/GuestHost/OpenGL/util/timer.c
index cad0d95..b4f34b8 100644
--- src/VBox/GuestHost/OpenGL/util/timer.c
+++ src/VBox/GuestHost/OpenGL/util/timer.c
@@ -35,7 +35,7 @@ static double crTimerGetTime( CRTimer *t )
 #elif defined( WINDOWS )
 	QueryPerformanceCounter( &t->performance_counter );
 	return ((double) t->performance_counter.QuadPart)*t->one_over_frequency;
-#elif defined( Linux ) || defined( FreeBSD ) || defined(DARWIN) || defined(AIX) || defined(SunOS) || defined(OSF1)
+#elif defined( Linux ) || defined( FreeBSD ) || defined(DARWIN) || defined(AIX) || defined(SunOS) || defined(OSF1) || defined(NetBSD)
 	gettimeofday( &t->timeofday, NULL );	
 	return t->timeofday.tv_sec + t->timeofday.tv_usec / 1000000.0;
 #else
diff --git src/VBox/GuestHost/OpenGL/util/vboxhgcm.c src/VBox/GuestHost/OpenGL/util/vboxhgcm.c
index 7290b7b..ec7b794 100644
--- src/VBox/GuestHost/OpenGL/util/vboxhgcm.c
+++ src/VBox/GuestHost/OpenGL/util/vboxhgcm.c
@@ -623,7 +623,7 @@ static int crVBoxHGCMCall(CRConnection *conn, void *pvData, unsigned cbData)
     }
 # else
     int rc;
-#  if defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD)
+#  if defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD) || defined(RT_OS_NETBSD)
     VBGLBIGREQ Hdr;
     Hdr.u32Magic = VBGLBIGREQ_MAGIC;
     Hdr.cbData = cbData;
@@ -1405,7 +1405,7 @@ static int crVBoxHGCMDoConnect( CRConnection *conn )
                         &info, sizeof (info),
                         &cbReturned,
                         NULL))
-#elif defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD)
+#elif defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD) || defined(RT_OS_NETBSD)
     VBGLBIGREQ Hdr;
     Hdr.u32Magic = VBGLBIGREQ_MAGIC;
     Hdr.cbData = sizeof(info);
@@ -1560,7 +1560,7 @@ static void crVBoxHGCMDoDisconnect( CRConnection *conn )
         {
             crDebug("Disconnect failed with %x\n", GetLastError());
         }
-# elif defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD)
+# elif defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD) || defined(RT_OS_NETBSD)
         VBGLBIGREQ Hdr;
         Hdr.u32Magic = VBGLBIGREQ_MAGIC;
         Hdr.cbData = sizeof(info);
diff --git src/VBox/GuestHost/OpenGL/util/vboxhgsmi.c src/VBox/GuestHost/OpenGL/util/vboxhgsmi.c
index 3da3496..06c1b0e 100644
--- src/VBox/GuestHost/OpenGL/util/vboxhgsmi.c
+++ src/VBox/GuestHost/OpenGL/util/vboxhgsmi.c
@@ -255,7 +255,7 @@ static int crVBoxHGCMCall(void *pvData, unsigned cbData)
     return VERR_NOT_SUPPORTED;
 # else
     int rc;
-#  if defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD)
+#  if defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD) || defined(RT_OS_NETBSD)
     VBGLBIGREQ Hdr;
     Hdr.u32Magic = VBGLBIGREQ_MAGIC;
     Hdr.cbData = cbData;
@@ -1258,7 +1258,7 @@ static int crVBoxHGSMIDoConnect( CRConnection *conn )
                         &info, sizeof (info),
                         &cbReturned,
                         NULL))
-#elif defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD)
+#elif defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD) || defined(RT_OS_NETBSD)
     VBGLBIGREQ Hdr;
     Hdr.u32Magic = VBGLBIGREQ_MAGIC;
     Hdr.cbData = sizeof(info);
@@ -1370,7 +1370,7 @@ static void crVBoxHGSMIDoDisconnect( CRConnection *conn )
         {
             crDebug("Disconnect failed with %x\n", GetLastError());
         }
-# elif defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD)
+# elif defined(RT_OS_SOLARIS) || defined(RT_OS_FREEBSD) || defined(RT_OS_NETBSD)
         VBGLBIGREQ Hdr;
         Hdr.u32Magic = VBGLBIGREQ_MAGIC;
         Hdr.cbData = sizeof(info);
diff --git src/VBox/Makefile.kmk src/VBox/Makefile.kmk
index 7bb7035..14f819a 100644
--- src/VBox/Makefile.kmk
+++ src/VBox/Makefile.kmk
@@ -22,7 +22,7 @@ include $(KBUILD_PATH)/subheader.kmk
 ifdef VBOX_ONLY_ADDITIONS
  include $(PATH_SUB_CURRENT)/Runtime/Makefile.kmk
  if defined(VBOX_WITH_CROGL) || defined(VBOX_WITH_HGSMI)
-  if1of ($(KBUILD_TARGET),win linux solaris freebsd haiku)
+  if1of ($(KBUILD_TARGET),win linux solaris freebsd haiku netbsd)
    include $(PATH_SUB_CURRENT)/GuestHost/Makefile.kmk
   endif
  endif
